﻿using InABox.Configuration;
using System;
using System.Collections.Generic;
using System.Text;

namespace InABox.Core
{
    /// <summary>
    /// The global settings for an <see cref="IPostable"/> of a certain <typeparamref name="TEntity"/>.
    /// </summary>
    /// <typeparam name="TEntity"></typeparam>
    public class PostableSettings<TEntity> : IGlobalConfigurationSettings
        where TEntity : Entity, IPostable
    {
        /// <summary>
        /// What kind of <see cref="IPoster{TEntity, TSettings}"/> is to be used, globally; this will be a type name.
        /// </summary>
        [ComboLookupEditor(typeof(PosterTypeLookup))]
        public string PosterType { get; set; }
    }
}
