﻿using InABox.Clients;
using System.Linq;

namespace InABox.Core
{
    internal class PosterTypeLookup : LookupGenerator<object>
    {
        public PosterTypeLookup(object[]? items) : base(items)
        {
            var classes = CoreUtils.Entities.Where(
                x => x.IsSubclassOf(typeof(Entity))
                && x.HasInterface(typeof(IPoster<,>)))
                .OrderBy(x => x.EntityName().Split('.').Last()).ToArray();
            foreach (var entity in classes)
                if (ClientFactory.IsSupported(entity))
                    AddValue(entity.EntityName(), entity.EntityName().Split('.').Last());
        }
    }
}