using Syncfusion.SfDataGrid.XForms;
using Xamarin.Forms;

namespace InABox.Mobile
{
    
    public enum MobileGridImageAspect
    {
        Fill,
        Fit
    }
    
    public class MobileGridImageColumn<TEntity> : MobileGridColumn<TEntity, ImageSource>
    {

        public MobileGridImageAspect Aspect { get; set; } = MobileGridImageAspect.Fit;
        
        public double Margin { get; set; }
        
        public MobileGridImageColumn() : base()
        {
            Width = 40;
        }
        
        public override GridColumn CreateColumn()
        {
            var result = CreateColumn<GridImageColumn>();
            result.Padding = Margin;
            result.Aspect = Aspect == MobileGridImageAspect.Fill
                ? Xamarin.Forms.Aspect.AspectFill
                : Xamarin.Forms.Aspect.AspectFit;
            return result;
        }
    }
}