using System;
using System.Collections;
using System.Linq;
using System.Windows.Input;
using Xamarin.Forms;
using Xamarin.Forms.Xaml;
using XF.Material.Forms.UI.Dialogs;

namespace InABox.Mobile
{

    public class MobileListRefreshEventArgs : EventArgs
    {
    }
    
    public delegate void MobileListRefreshEvent(object sender, MobileListRefreshEventArgs args);
    
    
    // public class MobileListDataTemplateSelector : DataTemplateSelector
    // {
    //     
    //     protected override DataTemplate OnSelectTemplate(object item, BindableObject container) => new DataTemplate(typeof(DeliveryListEntry));
    // }

    [XamlCompilation(XamlCompilationOptions.Compile)]
    public partial class MobileList
    {

        public bool PullToRefresh
        {
            get => _refresher.IsEnabled == true;
            set => _refresher.IsEnabled = value;
        }

        // public int RowHeight
        // {
        //     get => _viewmodel.RowHeight;
        //     set => _viewmodel.RowHeight = value;
        // }
        
        public DataTemplate ItemTemplate
        {
            get => BindableLayout.GetItemTemplate(_list); 
            set => BindableLayout.SetItemTemplate(_list,value); 
        }
        
        public IEnumerable ItemsSource
        {
            get => BindableLayout.GetItemsSource(_list);
            set => BindableLayout.SetItemsSource(_list,value);
        }

        public double Spacing
        {
            get => _list.Spacing;
            set => _list.Spacing = value;
        }
        
        public event MobileListRefreshEvent Refresh;

        public MobileList()
        {
            InitializeComponent();
            _refresher.Command = new Command(DoRefresh);
        }
        
        private void DoRefresh(object sender)
        {
            if (_refresher != null)
            {
                _refresher.IsRefreshing = true;
                Refresh?.Invoke(sender, new MobileListRefreshEventArgs());
                _refresher.IsRefreshing = false;
            }
        }
        
    }
}