using System;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

using Xamarin.Forms;
using Xamarin.Forms.Xaml;

namespace InABox.Mobile
{

    
    public class MobileMenuItem : BindableObject
    {
        public String Text { get; set; }
        
        public event EventHandler Clicked;

        public void DoClicked()
        {
            Clicked?.Invoke(this, EventArgs.Empty);
        }
    }
    
    public class MobileMenuButtonMenuViewModel : BindableObject
    {
        public IList<MobileMenuItem> Items { get; private set; }
        
        public MobileMenuButtonMenuViewModel()
        {
            Items = new ObservableCollection<MobileMenuItem>();
        }
    }
    
    [XamlCompilation(XamlCompilationOptions.Compile)]
    public partial class MobileMenuButtonMenu
    {
        public IList<MobileMenuItem> Items => _viewModel.Items;
        
        public MobileMenuButtonMenu()
        {
            InitializeComponent();
        }

        private void TapGestureRecognizer_OnTapped(object sender, EventArgs e)
        {
            if ((sender as Label)?.BindingContext is MobileMenuItem item)
                item.DoClicked();
        }
        
    }
}