using System;
using System.Globalization;
using Xamarin.Forms;

namespace InABox.Mobile
{
    public class EmptyConverterConvertingEventArgs : EventArgs
    {
        public object Value { get; private set; }

        public EmptyConverterConvertingEventArgs(object value)
        {
            Value = value;
        }
    }

    public delegate void EmptyConverterConvertingHandler(object sender, EmptyConverterConvertingEventArgs args);
    
    public class EmptyConverter : IValueConverter
    {
        public event EmptyConverterConvertingHandler Converting;
        
        public object Convert(object value, Type targetType, object parameter, CultureInfo culture)
        {
            Converting?.Invoke(this, new EmptyConverterConvertingEventArgs(value));
            return value;
        }

        public object ConvertBack(object value, Type targetType, object parameter, CultureInfo culture)
        {
            return value;
        }
    }
}